/****************************************************************************/
/*                 DOF/ Calculator for Canon Cam's     	    	    */
/****************************************************************************/
/* Created:       03.01.2007 [BORLAND C 3.1]                                */
/* Last modified: 27.01.2007 [BORLAND C 3.1]	                            */
/* Copyright (C) 2006 by AlexG (special thanks to RayeR)                    */
/* Compiler: Borland C++ 3.1, disable Word Alignment, set 80186 code gen.   */
/****************************************************************************/

#include "common.h"
#define CAMERA_S70
#include "psiolib.c"                   // PowerShot I/O library 2.0+
#include "tiff.c"
#include <stdio.h>
#include <dos.h>
#include <dir.h>
#include <direct.h>



void BrLine(u16 x0,u16 y0,u16 x1,u16 y1, Byte size, Word color)
{
  s8  s1, s2;
  u16 xc,yc,i;
  s16 dx, dy, r, e;
  u8 exch;

  dx = x1 - x0; s1 = (dx<0)?-1:1; dx *= s1;
  dy = y1 - y0; s2 = (dy<0)?-1:1; dy *= s2;
  exch = (dy>dx);
  if (exch)
  {
    r = dx; dx = dy; dy = r;
  }
  xc = x0; yc = y0;
  ps_put_pixel(xc,yc,size,color);
  e = 2 * dy - dx;
  for ( i = 0; i<dx; ++i )
  {
    for ( ; e>=0; e -= 2 * dx )
    {
      if (exch)
      {
	xc += s1;
	ps_put_pixel(xc,yc,size,color);
      }
      else
      {
	yc += s2;
	ps_put_pixel(xc,yc,size,color);
      }
    }
    if (exch)
    {
      yc += s2;
      ps_put_pixel(xc,yc,size,color);
    }
    else
    {
      xc += s1;
      ps_put_pixel(xc,yc,size,color);
    }
    e += 2 * dy;
  }
}

//**************** display single-line formatted string on LCD (one '\n' allowed at end only!)
void ps_printf_rus(Byte refresh, Word txtcolor, Word dmode, char *formatstring,...)
{                                      // doesn't scroll when bottom of screen reached!
  char msgbuf[80];                     // buffer for formated text messages
  vsprintf(msgbuf,formatstring,...);   // print formatted text to buffer
  if (msgbuf[strlen(msgbuf)-1]=='\n')  // is last char '\n' ?
    msgbuf[strlen(msgbuf)-1]=0;        // remove it
  
  for(u8 i=0;i<strlen(msgbuf);i++) if ((msgbuf[i]>127)&&(msgbuf[i]<176)) msgbuf[i]+=48;
                                               
  ps_print(msgbuf,ps_where_x,ps_where_y,txtcolor,dmode,refresh);
  if (formatstring[strlen(formatstring)-1]=='\n')
    {                                  // is last char '\n'
    ps_where_x=0;                      // reset x position
    if (ps_where_y<(PS_SCREEN_YRES-2*PS_FONT_H)) // is not last line?
      ps_where_y+=2*PS_FONT_H;         // move y position one line down
    }
  else                                 // update x position
    ps_where_x+=PS_FONT_W*strlen(msgbuf);
}


u16 atou(const char *s)
{
u8 tmp;
u8 i;
u16 result=0;

while((s[i]>47)&&(s[i]<58))
 {
  tmp=s[i]-48;
  result=result*10+tmp;
 }
return result;
}

struct f_rec
{
 u8   dir_num;
 u16 file_num;
};


int main(void)
{
DWord key;

  u16 f_ar[9]={581,728,856,991,1141,1316,1516,1747,2069};
  u8 A_ar[11]={28,32,35,40,45,50,53,56,63,71,80};
  u8 f_ind=0;
  u8 a_ind=0;
  u16 f;
  u16 A;
  u16 p=330;
  u8 d=47;
  u16 p1,p2,h;
  u16 tmpf;
  u8    tmpi;
  u8 x=0;
  u16 w=200;
  u8 refresh=1;
  u8 scr_num=0;
  struct ffblk ffblk;
  struct ffblk ffblk2;
  int done,done2;
  #define base_size 250
  f_rec fbase[base_size];
  u8 base_ptr=0;
  u8 dirnum;
  u16 filnum;
  char default_dir[]={"d:\\DCIM\\000CANON\\img_0000.jpg"};
  u16 dirlist[8];
  u8  dir_ptr;
  u8 search_files=0;
  u8 screen_pos=0;
  u8 cur_pos=0;
  u16 step;
  u16 pid;
  u8  limits=0;
  u8  demo=0;

  ps_init();
  ps_cls(0,0);
  ps_set_pal(ps_default_palette,0);

  pid=ps_get_pid();

    switch(pid)
    {
/*     case 0x309D: d=54;  //Pro1
		  break;*/
     case 0x30B3: d=47;  //G6  +
		  break;
     case 0x3085: d=56;  //G5  +
		  break;
     case 0x306E:
     case 0x306F: d=63;  //G3  +
		  break;
     case 0x30B1: d=47;  //S70 +
		  limits=1;
		  break;
     case 0x30B2: d=56;  //S60 +
		  limits=1;
		  break;
     case 0x3077: d=56;  //S50 +
		  break;
     case 0x306C:
     case 0x306D: d=63;  //S45 +
		  break;
/*     case 0x30C2: d=57;  //A510
		  break;
     case 0x30C1: d=51;  //A520
		  break;
     case 0x30B7: d=44;  //A400
		  break;*/
     case 0x30BB: d=56;  //A95 +
		  break;
/*     case 0x30B9: d=48;  //A85
		  break;*/
     case 0x309A: d=63;  //A80 +
		  break;
/*     case 0x30B5: d=53;  //A75
		  break;
     case 0x3073: d=53;  //A70
		  break;
     case 0x3074: d=68; //A60
		  break;
     case 0x3058: d=68; //A40
		  break;
     case 0x3072: d=53; //Ixus II
		  break;*/
     case 0x3075: d=63; //Ixus 400
		  break;
     default: demo=1;
    }


  do {
    key=ps_get_key_state();

    if (key&PS_KEY_DISP)
     {
      if (scr_num==1) scr_num=0;
      else scr_num=1;
      search_files=1;
      refresh=1;
     }
    if (key&PS_KEY_SET)
     {
      if (scr_num==2) scr_num=0;
      else scr_num=2;
      refresh=1;
     }

    if (scr_num==0)
    {

    if (key&PS_KEY_RIGHT)
    {
      x++;
      refresh=1;
    }
    if (x>2) x=0;
    if (key&PS_KEY_LEFT)
    {
      x--;
      refresh=1;
    }
    if (x>2) x=2;
    if (key&PS_KEY_UP)
    {
      if (x==0&&f_ind<8)  f_ind++;
      if (x==1&&a_ind<10)
      {
	a_ind++;
	if (limits)
	if (f_ind!=8&&a_ind==6) a_ind=7;
      }
      if (x==2)
	{
	 step=p/10;
	 if (!step) step=1;
	 p+=step;
	}
      refresh=1;
    }
    if (key&PS_KEY_DOWN)
    {
      if (x==0&&f_ind>0) f_ind--;
      if (x==1&&a_ind>0)
      {
	a_ind--;
	if (limits)
	if (f_ind!=8&&a_ind==6) a_ind=5;
      }
      if (x==2)
	{
	 step=p/10;
	 if (!step) step=1;
	 if (p) p-=step;
	}
      refresh=1;
    }
    if (refresh)
    {
      if (limits)
      switch(f_ind)
      {
	case 0: break;
	case 1: if (a_ind<1) a_ind=1; break;
	case 2: if (a_ind<1) a_ind=1; break;
	case 3: if (a_ind<2) a_ind=2; break;
	case 4: if (a_ind<3) a_ind=3; break;
	case 5: if (a_ind<3) a_ind=3; break;
	case 6: if (a_ind<4) a_ind=4; break;
	case 7: if (a_ind<5) a_ind=5; break;
	case 8: if (a_ind<6) a_ind=6; break;
      }

      ps_gotoxy(0,0);
      ps_fast_cls(6,0);
      if (ps_get_lang_id()==11) ps_printf_rus(0,14,0,"**   0.6d by AlexG ***");
      else ps_printf(0,14,0,"*** DOF calculator 0.6d by AlexG ***");
      ps_draw_frect(0,40,PS_SCREEN_XRES,340,14,0);

      f=f_ar[f_ind];
      A=A_ar[a_ind];
      h=((u32)f*f)/(A*d*2);
      p1=((u32)h*p)/(h+p);
      p2=((u32)h*p)/(h-p);
      tmpf=(170l*(p2-p))/p;
      if (tmpf<170) tmpi=tmpf;
      else tmpi=170;
      if (p<h) ps_draw_frect(0,210-tmpi,PS_SCREEN_XRES,tmpi,4,0);
      else     ps_draw_frect(0,40,PS_SCREEN_XRES,170,4,0);
      tmpf=(170l*(p-p1))/p;
      if (tmpf<170) tmpi=tmpf;
      else tmpi=170;
	       ps_draw_frect(0,210,PS_SCREEN_XRES,tmpi,4,0);

      f=f_ar[f_ind];
      A=A_ar[a_ind];
      h=((u32)f*f)/(A*d);
      p1=((u32)h*p)/(h+p);
      p2=((u32)h*p)/(h-p);
      tmpf=(170l*(p2-p))/p;
      if (tmpf<170) tmpi=tmpf;
      else tmpi=170;
      if (p<h) ps_draw_frect(0,210-tmpi,PS_SCREEN_XRES,tmpi,3,0);
      else     ps_draw_frect(0,40,PS_SCREEN_XRES,170,3,0);
      tmpf=(170l*(p-p1))/p;
      if (tmpf<170) tmpi=tmpf;
      else tmpi=170;
	       ps_draw_frect(0,210,PS_SCREEN_XRES,tmpi,3,0);

      ps_draw_frect(0,210,PS_SCREEN_XRES,4,2,0);

      w=(720*340l)/(2*f);
      BrLine(PS_SCREEN_XRES/2,378,PS_SCREEN_XRES/2-w,40,3,7);
      BrLine(PS_SCREEN_XRES/2,378,PS_SCREEN_XRES/2+w,40,3,7);
      ps_gotoxy(0,1);
      if (p<h) ps_printf(0,15,0," p2=%u.%.2um\n",p2/100,p2%100);
      else     ps_printf(0,15,0," p2=inf\n");
      ps_printf(0,15,0," p1=%u.%.2um\n",p1/100,p1%100);
      if (p<h) ps_printf(0,15,0," p =%u.%.2um\n",(p2-p1)/100,(p2-p1)%100);
      else     ps_printf(0,15,0," p =inf\n");
      ps_gotoxy(13,3);
      ps_printf(0,15,0," %u.%.2um ",p/100,p%100);
      ps_gotoxy(0,5);
      ps_printf(0,15,0," H =%u.%.2um\n",h/100,h%100);
      ps_draw_frect(x*(PS_SCREEN_XRES/4),380,PS_SCREEN_XRES/4,50,4,0);
      if (demo)
	{
	 ps_gotoxy(14,1); ps_printf(0,2,0,"DEMO");
	}
      ps_gotoxy(0,8);
      ps_printf(0,14,0,"f=%u.%.2umm   F/%u.%.1u   %2u.%.2um \n",f/100,f%100,A/10,A%10,p/100,p%100);
      if (ps_get_lang_id()==11) ps_printf_rus(1,14,0,"[disp]-䠩[set]-[menu]-室");
      else  ps_printf(1,14,0,"[disp]-files [set]-help [menu]-exit");
      refresh=0;
    }
    }
    else
    if (scr_num==1)
    {
     if (key&PS_KEY_UP)
       {
	if (cur_pos) cur_pos--;
	else
	 {
	  if (screen_pos) screen_pos--;
	  else
	   {
	    if (base_ptr>0)
	      {
	       if (base_ptr<10) cur_pos=base_ptr-1;
		else
		 {
		  cur_pos=9;
		  screen_pos=base_ptr-10;
		 }
	      }
	   }
	 }
	refresh=1;
       }
     if (key&PS_KEY_DOWN)
       {
	if (cur_pos<9) cur_pos++;
	else
	 {
	  if ((screen_pos+cur_pos)<(base_ptr-1)) screen_pos++;
	  else
	   {
	    cur_pos=0;
	    screen_pos=0;
	   }
	 }
	refresh=1;
       }

     if (refresh)
     {
     if (search_files)
     {
     setdisk(3);
     chdir("d:\\DCIM");
     base_ptr=0;
     dir_ptr=0;
     done = findfirst("???CANON",&ffblk,FA_DIREC);
     while (!done)
     {
      if (dir_ptr<8) dirlist[dir_ptr++]=(ffblk.ff_name[0]-48)*100+(ffblk.ff_name[1]-48)*10+(ffblk.ff_name[2]-48);
      done = findnext(&ffblk);
     }

     for(u8 k=0;k<dir_ptr;k++)
      {
       dirnum=dirlist[k];
       default_dir[ 8]=(dirnum/100)%10+48;
       default_dir[ 9]=(dirnum/10)%10+48;
       default_dir[10]=(dirnum%10)+48;

	 default_dir[16]=0;
	 chdir(default_dir);
	 default_dir[16]='\\';
	 done2 = findfirst("img_????.jpg",&ffblk2,0);
	 while (!done2)
	  {
	   filnum=(ffblk2.ff_name[4]-48)*1000+(ffblk2.ff_name[5]-48)*100+(ffblk2.ff_name[6]-48)*10+(ffblk2.ff_name[7]-48);
	   if (base_ptr<base_size)
	     {
	      fbase[base_ptr].dir_num =dirnum;
	      fbase[base_ptr].file_num=filnum;
	      base_ptr++;
	     }
	   done2 = findnext(&ffblk2);
	  }
      }

     //sortirovka bazy
     u8 perest;
     f_rec btmp;
     do {
     perest=0;
     for(u8 z=0;z<(base_ptr-1);z++)
     {
      if (fbase[z+1].file_num<fbase[z].file_num)
	{
	 btmp=fbase[z+1];
	 fbase[z+1]=fbase[z];
	 fbase[z]=btmp;
	 perest=1;
	}
     }
     }while(perest);
     //***************

     if (base_ptr>0)
       {
	if (base_ptr<10) cur_pos=base_ptr-1;
	else
	 {
	  cur_pos=9;
	  screen_pos=base_ptr-10;
	 }
       }

     search_files=0;
     }
     if (!search_files)
     {
      ps_fast_cls(6,0);
      ps_gotoxy(0,0);
      for(u8 i=0;i<10;i++)
	if (cur_pos==i) ps_printf(0, 2,0," %u\n",fbase[i+screen_pos].file_num);
	else            ps_printf(0,14,0," %u\n",fbase[i+screen_pos].file_num);
      ps_gotoxy(5,0);
      dirnum=fbase[cur_pos+screen_pos].dir_num;
      filnum=fbase[cur_pos+screen_pos].file_num;
      default_dir[21]=(filnum/1000)%10+48;
      default_dir[22]=(filnum/100)%10+48;
      default_dir[23]=(filnum/10)%10+48;
      default_dir[24]=(filnum%10)+48;
      default_dir[ 8]=(dirnum/100)%10+48;
      default_dir[ 9]=(dirnum/10)%10+48;
      default_dir[10]=(dirnum%10)+48;

       ps_printf(0,14,0," %s\n",default_dir);

	exif_read(default_dir);

	ps_draw_frect(120,100,PS_SCREEN_XRES-125,370,14,0);

      p=ex_p;
      f=ex_f;
      A=ex_a;
      h=((u32)f*f)/(A*d*2);
      p1=((u32)h*p)/(h+p);
      p2=((u32)h*p)/(h-p);
      tmpf=(185l*(p2-p))/p;
      if (tmpf<185) tmpi=tmpf;
      else tmpi=185;
      if (p<h) ps_draw_frect(120,283-tmpi,PS_SCREEN_XRES-125,tmpi,4,0);
      else     ps_draw_frect(120,100,PS_SCREEN_XRES-125,185,4,0);
      tmpf=(185l*(p-p1))/p;
      if (tmpf<185) tmpi=tmpf;
      else tmpi=185;
	       ps_draw_frect(120,283,PS_SCREEN_XRES-125,tmpi,4,0);

      h=((u32)f*f)/(A*d);
      p1=((u32)h*p)/(h+p);
      p2=((u32)h*p)/(h-p);
      tmpf=(170l*(p2-p))/p;
      if (tmpf<185) tmpi=tmpf;
      else tmpi=185;
      if (p<h) ps_draw_frect(120,283-tmpi,PS_SCREEN_XRES-125,tmpi,3,0);
      else     ps_draw_frect(120,100,PS_SCREEN_XRES-125,185,3,0);
      tmpf=(185l*(p-p1))/p;
      if (tmpf<185) tmpi=tmpf;
      else tmpi=185;
	       ps_draw_frect(120,283,PS_SCREEN_XRES-125,tmpi,3,0);

      ps_draw_frect(120,283,PS_SCREEN_XRES-125,4,2,0);

      w=(720*370l)/(2*f);
      BrLine(422,469,422-w,100,3,7);
      BrLine(422,469,422+w,100,3,7);

      ps_gotoxy(6,2);
      if (p<h) ps_printf(0,15,0,"p2=%u.%.2um\n",p2/100,p2%100);
      else     ps_printf(0,15,0,"p2=inf\n");
      ps_gotoxy(6,3);
      ps_printf(0,15,0,"p1=%u.%.2um\n",p1/100,p1%100);
      ps_gotoxy(6,4);
      if (p<h) ps_printf(0,15,0,"p =%u.%.2um\n",(p2-p1)/100,(p2-p1)%100);
      else     ps_printf(0,15,0,"p =inf\n");
      ps_gotoxy(16,5);
      ps_printf(0,15,0," %u.%.2um ",p/100,p%100);
      ps_gotoxy(6,6);
      ps_printf(0,15,0,"H =%u.%.2um\n",h/100,h%100);
      if (demo)
	{
	 ps_gotoxy(17,2); ps_printf(0,2,0,"DEMO");
	}
      ps_gotoxy(6,1);
      ps_printf(1,14,0,"f=%u.%.2umm F/%u.%.1u %2u.%.2um",ex_f/100,ex_f%100,ex_a/10,ex_a%10,ex_p/100,ex_p%100);
     }
      refresh=0;
     }
    }
    else
    if (scr_num==2)
    {
      ps_fast_cls(6,0);
      ps_gotoxy(0,0);
      if (ps_get_lang_id()==11)
	{
	 ps_printf_rus(0,14,0,"****   -   ****\n");
	 ps_printf_rus(0,14,0," p2 -  ࠭  १\n");
	 ps_printf_rus(0,14,0," p1 -  ࠭  १\n");
	 ps_printf_rus(0,14,0," p - 㡨 १ࠦ  \n");
	 ps_printf_rus(0,14,0,"      ࠭⢠\n");
	 ps_printf_rus(0,14,0," H  - 䮪쭮 ﭨ\n");
	 ps_printf_rus(0,14,0,"񬭮 -  ᨬ쭮 \n");
	 ps_printf_rus(0,14,0,"ࠧ襭 (); ᢥ⫮ - \n");
	 ps_printf_rus(0,14,0,"  襣 ࠧ襭\n");
	 ps_printf_rus(1,14,0,"ᨭ - 㣮 ७;  -ꥪ\n");
	}
       else
	{
	 ps_printf(0,14,0,"****** DOF calculator - HELP  ******\n");
	 ps_printf(0,14,0," p2 - far DOF limit\n");
	 ps_printf(0,14,0," p1 - near DOF limit\n");
	 ps_printf(0,14,0," p  - Depth of Field\n");
	 ps_printf(0,14,0," H  - Hyperfocal Distance\n");
	 ps_printf(0,14,0,"  Diagram:\n");
	 ps_printf(0,14,0," dark green -DOF; light green - zone \n");
	 ps_printf(0,14,0," with the doubly lower resolution;\n");
	 ps_printf(0,14,0," blue - viewing angle;\n");
	 ps_printf(1,14,0," red - object distance.\n");
	}
      refresh=0;
    }
  } while ((key&PS_KEY_MENU)==0);
  return(0);
}