#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <alloc.h>
#include <string.h>
#include "common.h"
//#include "psiolib.c"                   // PowerShot I/O library 2.0+

typedef unsigned short WORD;
typedef unsigned char BYTE;
typedef unsigned long DWORD;


typedef struct { WORD tag; char desc[32]; char** SwitchDesc; } TAGDESC;


u16 ex_f;//Focal Length
u8  ex_a;//F-Number
u16 ex_p;//Subject Distance
u16 ex_t;//Exposure

typedef struct { WORD val;WORD type;DWORD count;DWORD offs;} TAG;
typedef struct { int nTags; TAG data[];} IFD;

IFD* readIFD(int fd, DWORD offs)
{ int i,n; IFD* p;

  if (lseek(fd,offs,SEEK_SET)==-1L) return NULL;
  _read(fd,&n,2);
  p=(IFD*)malloc(n*12+2);
  if(!p) return NULL;
  p->nTags=n;
  _read(fd,p->data,n*12);

  return p;
};

void describemntag(int fd, TAG* tg)
{
    if(tg->val==0x4)
     {
      if (lseek(fd,tg->offs+12+19*2,SEEK_SET)<0) return;
      _read(fd,&ex_p,2);
     }
}

void ParseMakernote(int fd, long offs)
{ int i;
  IFD* mnIFD;

  if(!(mnIFD=readIFD (fd,offs+12))) return;
  for(i=0;i<mnIFD->nTags;i++) describemntag(fd,mnIFD->data+i);
  free(mnIFD);
}

void describetag( int fd, TAG* tg)
{ int i;  DWORD l;
  struct { DWORD l1,l2; } rat;

  if (tg->val==0x920A)//Focal Length
    {
     if (lseek(fd,tg->offs+12,SEEK_SET)<0) return;
     if (_read(fd,&rat,8)!=8) return;
     if (rat.l2!=0)
       {
	ex_f=(rat.l1*100)/rat.l2;
       }
     else
       {
	ex_f=0xFFFF;
       }
    }
  if (tg->val==0x829D)//F-Number
    {
     if (lseek(fd,tg->offs+12,SEEK_SET)<0) return;
     if (_read(fd,&rat,8)!=8) return;
     if (rat.l2!=0)
       {
	ex_a=(rat.l1*10)/rat.l2;
       }
     else
       {
	ex_a=0xFFFF;
       }
    }
  if (tg->val==0x829A)//Exposure
    {
     if (lseek(fd,tg->offs+12,SEEK_SET)<0) return;
     if (_read(fd,&rat,8)!=8) return;
     if (rat.l2!=0)
       {
	ex_t=(rat.l1*1000)/rat.l2;
       }
     else
       {
	ex_t=0xFFFF;
       }
    }
  if (tg->val==0x0110)//Model
    {
  /* if(tg->count<=4) { ps_printf(0,14,0,"1%s",&(tg->offs)); break; } // ascii
     if (lseek(fd,tg->offs+extoffs+12,SEEK_SET)==-1L || (str=(char*) malloc(tg->count))==NULL ) { ps_printf(0,14,0,"<error>"); break; }
     _read(fd,str,tg->count); ps_printf(0,14,0,"%s",str); free(str); break;*/
    }

  if(tg->val==0x927C) { ParseMakernote(fd,tg->offs); return; }
}

u8 exif_read(char* argv)
{  int i,fd;
   IFD *ifd0,*ifdE=NULL;
   int Endian=0;

   _fmode=O_BINARY;
   fd=open(argv,O_RDONLY|O_BINARY);
   if(fd<0) return 1;
   lseek(fd, 12,SEEK_SET);
   read(fd,&Endian,2);
   if (Endian!='II') return 1;
   ifd0=readIFD(fd,20);
   if(!ifd0) return 1;
   for(i=0;i<ifd0->nTags;i++) describetag(fd,ifd0->data+i);
   for(i=0;i<ifd0->nTags;i++)
     if ((ifd0->data)[i].val==0x8769) { ifdE=readIFD(fd,(ifd0->data)[i].offs+12); break;}
   if(!ifdE)  return 1;
   for(i=0;i<ifdE->nTags;i++) describetag(fd,ifdE->data+i);
   free(ifdE); free(ifd0);
   close(fd); return(0);
};
